/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Futex.xs. Do not edit this file, edit Futex.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Futex.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include <linux/futex.h>
#include <sys/stat.h>
#include <sys/syscall.h>
#include <sys/types.h>


void futex_wait(int *uadd, int val) {
    syscall(SYS_futex , uadd, FUTEX_WAIT, val, NULL, NULL, 0);
}

void futex_wake(int *uadd, int num) {
    syscall(SYS_futex , uadd, FUTEX_WAKE, num, NULL, NULL, 0);
}

/* var replaced with new if current value = old. old value always returned */
static int cmpxchg (int *var, int old, int new) {
  int ret;

  asm ( "lock cmpxchg %3, %0\n\t"
        "mov %%eax, %1 \n\t"
	: "+m"(*var), "=g"(ret) : "a"(old), "b"(new) : "memory", "cc");
  return ret;
}

/* exchange the two atomically, return the original value of var */
static int xchg (int *var, int new) {
  int ret;
  asm ( "lock xchg %%eax, %0\n\t"
        "mov %%eax, %1 \n\t"
	: "+m"(*var), "=g"(ret) : "a"(new) : "memory");
  return ret;
}

/* Atomically decrement val by 1
 * return 0 if value becomes zero, else non-zero
 */
static int atomic_dec(int *val) {
    int ret;
    asm("lock decl %0\n\t"
        "lahf \n\t"
        "and $0x4000,%%eax \n\t"
        "ror $14, %%eax \n\t"
        "dec %%eax \n\t"
        : "+m"(*val), "=a"(ret) : : "memory", "cc");
    return ret;
}

static void *sv2addr(SV *sv)
{
  if (SvPOK(sv) && SvCUR(sv) == sizeof(void *))
  {
    return *((void **) SvPVX(sv));
  }

  croak("invalid address value");

  return 0;
}

#line 76 "Futex.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 220 "Futex.c"

XS_EUPXS(XS_Linux__Futex_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Futex_init)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "buf");
    {
	void *	buf = sv2addr(ST(0));
#line 74 "Futex.xs"
        *((int *)buf) = 0;
#line 232 "Futex.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__Futex_lock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Futex_lock)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "buf");
    {
	void *	buf = sv2addr(ST(0));
#line 80 "Futex.xs"
        int c;
        int *pmutex = (int *)buf;
        if ((c = cmpxchg (pmutex, 0, 1)) != 0) {
            if (c != 2)
                c = xchg (pmutex, 2);
            while (c != 0) {
                futex_wait (pmutex, 2);
                c = xchg (pmutex, 2);
            }
        }
#line 257 "Futex.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__Futex_unlock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Futex_unlock)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "buf");
    {
	void *	buf = sv2addr(ST(0));
#line 95 "Futex.xs"
        int *pmutex = (int *)buf;
        if (atomic_dec (pmutex) != 1) {
            *((int *)pmutex) = 0;
            futex_wake (pmutex, 1);
        }
#line 277 "Futex.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__Futex_addr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Futex_addr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "buf");
    {
	SV *	buf = ST(0)
;
#line 105 "Futex.xs"
        if (!SvPOK(buf)) croak("requires a string");

#line 295 "Futex.c"
#line 108 "Futex.xs"
        STRLEN len;
        char *mem = SvPV(buf, len);
        if (len < 4) croak("string must be at least four bytes");
        ST(0) = sv_2mortal(newSVpvn((char *) &mem, sizeof(void *)));
        XSRETURN(1);
#line 302 "Futex.c"
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Linux__Futex); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Linux__Futex)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Linux::Futex::init", XS_Linux__Futex_init);
        newXS_deffile("Linux::Futex::lock", XS_Linux__Futex_lock);
        newXS_deffile("Linux::Futex::unlock", XS_Linux__Futex_unlock);
        newXS_deffile("Linux::Futex::addr", XS_Linux__Futex_addr);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
